//
// Deferred Shading pass 2
//
#extension GL_ARB_texture_rectangle: enable

//varying	vec3 pos;
//uniform vec3 lightPos;
uniform sampler2DRect	posMap;
uniform sampler2DRect	normalMap;
uniform sampler2DRect	colorMap;

#define	MAX_DIST	1.5


void main (void)
{
	vec2	tex = gl_FragCoord.xy;
	float	dz  = abs ( texture2DRect ( posMap, tex - vec2 ( 1, 0 ) ).r -
                           texture2DRect ( posMap, tex + vec2 ( 1, 0 ) ).r ) + 
		     abs ( texture2DRect ( posMap, tex - vec2 ( 0, 1 ) ).r -
                           texture2DRect ( posMap, tex + vec2 ( 0, 1 ) ).r );

	float	dn  = length ( texture2DRect ( normalMap, tex - vec2 ( 1, 0 ) ).r -
                              texture2DRect ( normalMap, tex + vec2 ( 1, 0 ) ).r ) + 
		     length ( texture2DRect ( normalMap, tex - vec2 ( 0, 1 ) ).r -
                              texture2DRect ( normalMap, tex + vec2 ( 0, 1 ) ).r );
	vec3	c  = texture2DRect ( colorMap,  tex ).xyz;
	float	a  = 0.5*(dz+dn);
	vec4	clr = texture2DRect ( colorMap,  tex + vec2 ( a, 0.0 ) ) + 
			      texture2DRect ( colorMap,  tex - vec2 ( a, 0.0 ) ) + 
				  texture2DRect ( colorMap,  tex + vec2 ( 0.0, a ) ) + 
				  texture2DRect ( colorMap,  tex - vec2 ( 0.0, a ) );
	
	gl_FragColor = 0.25 * clr;
//	gl_FragColor = vec4 ( 0.5*(dz+dn) );
}
