//
// Deferred Shading pass 1 (transparent objects)
//

varying	vec3 pos;
varying	vec3 n;
varying	vec3 t;
varying	vec3 b;

uniform sampler2D	diffMap;
uniform sampler2D	bumpMap;

void main (void)
{
	vec3	nn    = 2.0*texture2D ( bumpMap, gl_TexCoord [0].xy ).xyz - vec3 ( 1.0 );
	float	alpha = 0.6;
	float	y     = gl_FragCoord.y * 0.5;
	
	if ( alpha < 1.0 ) 
		if ( fract ( y ) < 0.5 )
			discard; 
	
	nn = 0.5 * ( normalize ( nn.x * t + nn.y * b + nn.z * n ) + 1.0 );
	
	gl_FragData [0] = vec4 ( nn, 1.0 );
	gl_FragData [1] = vec4 ( texture2D ( diffMap, gl_TexCoord [0].xy ).rgb, alpha );
}
