
#extension GL_ARB_texture_rectangle: enable

varying	vec3 pos;
uniform vec3 lightPos;
uniform sampler2DRect	posMap;
uniform sampler2DRect	normalMap;

void main (void)
{
	vec3	p  = texture2DRect ( posMap,    gl_FragCoord.xy ).xyz;
	vec3	n  = texture2DRect ( normalMap, gl_FragCoord.xy ).xyz;
	float	z  = p.z;
	vec3	pp = pos * z / pos.z;
	vec3	l  = normalize ( lightPos - p );
	vec3	v  = normalize ( -p );
	vec3	h  = normalize ( l + v );
	float	diff = max ( 0.2, dot ( l, n ) );
	float	spec = pow ( max ( 0.0, dot ( h, n ) ), 40.0 );
	
	gl_FragColor = vec4 ( vec3 ( diff + spec ), 1.0 );
}
