//
// Deferred Shading pass 1
//

varying	vec3 pos;
varying	vec3 n;
varying	vec3 t;
varying	vec3 b;

uniform sampler2D	diffMap;
uniform sampler2D	bumpMap;

// pack a floating point value from [0,1] into RGBA8 vector

vec4 packFloatToVec4i ( const float value )
{
	const vec4 bitSh   = vec4 ( 256.0*256.0*256.0, 256.0 * 256.0, 256.0, 1.0 );
	const vec4 bitMask = vec4 ( 0.0, vec3 ( 1.0 / 256.0 ) );
	
	vec4	res = fract ( value * bitSh );
	
	return res - res.xxyz * bitMask;
}

void main (void)
{
	const float	zNear = 0.01;
	const float zFar  = 100.0;
	
	vec3	nn = 2.0*texture2D ( bumpMap, gl_TexCoord [0].xy ).xyz - vec3 ( 1.0 );
	
	nn = 0.5 * ( normalize ( nn.x * t + nn.y * b + nn.z * n ) + 1.0 );
	
	gl_FragData [0] = vec4 ( nn, 1.0 );
	gl_FragData [1] = texture2D ( diffMap, gl_TexCoord [0].xy );
	gl_FragData [2] = packFloatToVec4i ( -pos.z / zFar );
}
