//
// Deferred Shading alpha-blending of transparent object
//
#extension GL_ARB_texture_rectangle: enable

#define EPS 0.01

uniform sampler2DRect	colorMap;
uniform sampler2DRect	diffMap;

void main (void)
{
	vec4	c  = texture2DRect ( colorMap,  gl_FragCoord.xy );
	vec4	c2 = texture2DRect ( colorMap,  gl_FragCoord.xy + vec2 ( 0.0, 1.0 ) );
	float	a  = texture2DRect ( diffMap,  gl_FragCoord.xy ).a;
	float	a2 = texture2DRect ( diffMap,  gl_FragCoord.xy + vec2 ( 0.0, 1.0 ) ).a;
	
	if ( a2 < 1.0 - EPS )		// we have semitransparent pixels
		c = c * (1.0 - a2) + c2 * a2;
	else
	if ( a < 1.0 - EPS )
		c = c * a + c2 * (1.0 - a );

	gl_FragColor = vec4 ( c );
}
